# Datenbanken

*Dateiname: index.md*

![Datenbank Banner](bilder/datenbank.jpg)

## Was sind eigentlich Datenbanken


Datenbanken besitzen in der Praxis eine immense Bedeutung, bei der Verwaltung der stetig wachsenden Flut an Informationen.
Man schätzt, dass mehr als 50% der Software-Entwicklung in der Industrie auf dem Gebiet der betrieblichen Informationssysteme erfolgt.

i>Eine **Datenbank (DB)** (data base) ist eine systematisch strukturierte, langfristig verfügbare Sammlung von Daten.

---

## Datenbanken in unserem Alltag


t>**Aufgabe:** Was für Datenbanktypen gibt es?

<iframe width="560" height="315" src="https://www.youtube.com/embed/ZGWAAIqIB04" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>

- ...

t>**Aufgabe:** Wo finden sich Datenbanken in unserem Alltag?

- ...


---

w>Viele Nutzen für die Verarbeitung von größeren Datenmengen Tabellenkalkulation. Doch es gibt Gründe, das nicht zu tun. Hier eine kleine Gegenüberstellung:

### Tabellenkalkulation ist keine Datenbank!

**Tabellenkalkulation**

- Arbeit mit Tabellen
- unterstützt komplizierte Berechnungen
- einfache Datenbankabfragen möglich
- Grafiken können erstellt werden


**Datenbanken**

- Arbeit mit Tabellen
- unterstützt einfache Berechnungen
- Datenbankabfragen möglich und schnell
- mehrere Benutzer können auf die Datenbank zugreifen
- wird besonders darauf geachtet, dass Daten nicht verloren gehen
- unterstützt spezielle Datenbankfunktionen, wie die Aufteilung der Daten auf verschiedene Tabellen
- Redundanzvermeidung, Datenintegrität
- Fehlerbehandlung

---

Damit wir fachlich korrekt weiterarbeiten können, benötigt es eines gewissen Vokabulars.

t>**Aufgabe:** Recherchiere nach den fehlenden Erläuterungen `Datenbasis` und `Datenbanksystem`.

## Grundbegriffe

Begriff | Erläuterung
--------|------------
Datenbank(DB)|Systematisch strukturierte, langfristig verfügbare Sammlung von Daten (Menge von Nutz- und Meta-Daten)
Datensatz| Datenmenge zu einem Objekt / Sachverhalt
**Datenbasis**| `...`
Datenfeld|eine Eigenschaft des Objektes
Datenbankmanagmentsystem|Software zur Arbeit mit einer Datenbank, stellt Schnittstelle zum Benutzer dar
**Datenbanksystem**|`...`
---

## Grundoperationen in Datenbanken

Die Arbeit mit Datenbanken kann auf drei Grundoperationen begrenzt werden.

Abfragen | Mutation | DB-Schema verwalten/erstellen
--------|------------|-----------
Datenbestand wird nicht verändert | Datenbestand wird verändert | Festlegen der Grundstruktur einer Datenbank
Über spezielle Abfragesprache oder über verbreitete Eingabemaske | Daten einfügen / ändern / löschen | Tabellen definieren, Datenfelder und Wertebereiche definieren, *Zugriffsrechte festlegen*