# Logische Operatoren und Aggregation

*Dateiname: instaHub-aggregation.md*

## Logische Operatoren

Logische Operatoren kennst du schon aus verschiedenen Anwendungen, insbesondere der Algorithmierung aber auch bei der Aussagenlogik in Mathematik (Venn-Diagramme).
Genau jene machen wir uns nun für die Abfrage von Informationen zu Nutze.

Überlege, welche Ergebnisse die folgenden SQL-Befehle liefern könnte. Beschreibe kurz, welche Datensätze in der Ergebnistabelle enthalten sein werden.

**Beispiel 1** 

![Logische Operatoren Suchmaske](bilder/instahub-logischeoperatoren1.png)

```SQL
SELECT     username, city 
FROM     users 
WHERE     city = "Berlin" AND name LIKE "Fabian%"
```

*Lösung*

- ...

---

**Beispiel 2**

![Logische Operatoren Suchmaske](bilder/instahub-logischeoperatoren2.png)

```SQL
SELECT     username, city 
FROM     users 
WHERE     city = "Berlin" OR city = "Hamburg"
```

*Lösung*

- ...

---

### Übung

Erstelle eine Abfrage, die ...

t>alle Berliner auflistet, die Marc heißen,

```SQL
...
```

t>alle Leipziger Frauen auflistet,

```SQL
...
```

t>alle Linas und Lorenas auflistet,

```SQL
...
```

t>alle Männer nach ihrer Körpergröße auflistet, die mindestens 16 Jahre alt sind und

```SQL
...
```

t>alle Nutzer liefert, die weder männlich noch weiblich sind.

```SQL
...
```

--- 

### Und jetzt mal knifflig ... 

Erstellen Sie je eine (SQL-)Abfrage (Tipp: Verwenden Sie Klammern wie beim Taschenrechner), die

t>alle Benutzer mit dem Namen “Xaver” auflistet, die nicht in München oder Nürnberg leben und

```SQL
...
```

t>alle Benutzer*Innen auflistet, die 10 cm größer als der Durchschnitt ihrer Geschlechtsgenossen sind. (Die Durchschnittsgröße von Männern beträgt in Deutschland 179,9 cm, die von Frauen 165,9 cm)

```SQL
...
```

---

## Zusammenfassung (Aggregation)

Bisher hast du bei Abfragen

- die Spalten, die angezeigt werden sollen, ausgewählt (Projektion) oder
- die Zeilen, die im Ergebnis stehen sollen, ausgewählt (Selektion).
Aber was, wenn wir wissen wollen, wie groß unser größtes Mitglied in jeder Stadt ist? Oder wir für jede Stadt wissen wollen, wie viele Mitglieder wir dort haben?

Die Lösung hierfür heißt **Aggregat** (aggregieren: lat. anhäufen). Die Idee ist in der folgenden Abbildung dargestellt:

![Aggregation](bilder/aggregat.png)

Aggregate fassen also mehrere Zeilen der Quelltabellen zu einer einzigen Zeile in der Ergebnistabelle zusammen.

### Unser erstes Aggregat

Der folgende SELECT-Befehl liefert für jede Stadt den größten und kleinsten Benutzer:

```SQL
SELECT     city AS "Stadt", MIN(centimeters) AS "kleinsteR", MAX(centimeters) AS "groessteR"
FROM  users 
GROUP BY city
```

t>Probiere den Befehl aus und erkläre, wie er funktioniert. Beachte dabei alle neuen SQL-Wörter.

`MAX` ist eine Aggregatsfunktion. Weitere Aggregatsfunktionen sind beispielsweise `COUNT`,  `SUM` und `AVG` (Durchschnitt, engl. average).

### Übung

Erstelle je eine SQL-Abfrage, die

t>alle Werte des Feldes `gender` liefert und angibt, wie oft diese auftreten,

```SQL
...
```

t>die durchschnittliche Größe aller Mitglieder in Dresden liefert und

```SQL
...
```

t>das Geburtsdatum des jüngsten männlichen und des jüngsten weiblichen Mitglieds liefert.

```SQL
...
```