# Abfragen über mehrere Tabellen

*Dateiname: instaHub-join.md*

Oftmals stecken Informationen in verschiedenen Tabellen. So bedarf es einiger "Spalten" aus Tabelle 1 und einiger "Spalten" aus Tabelle 2. Doch wie finden die Datensätze der jeweiligen Person zusammen?
Dazu muss eine Verknüpfungsstelle geschaffen werden.

Für eine konkrete Abfrage hat das also folgende Konsequenz:

**Beispiel**

Gesucht ist eine Liste der Klassenleiter mit den jeweiligen Klassen.

```SQL
SELECT Klassen.Name, Lehrkraft.Name
FROM Lehrkraft, Klasse
WHERE Lehrkraft.PersNr = Klasse.Klassenleitung
```

Alternativ kann auch folgende Notation verwendet werden

```SQL
SELECT Klassen.Name AS k, Lehrkraft.Name AS l
FROM Lehrkraft, Klasse
WHERE l.PersNr = k.Klassenleitung
```

t>**Aufgaben**: Erläutere, worin sich die Anfragen unterscheiden? Welche Vorteile bringt dies?

*Lösung*

...

### Schlussfolgerung

i>Für die Abfragen über mehrere Tabellen müssen bei FROM alle benötigten Tabellen gelistet werden und eine passende Verknüpfungsstelle der Datensätze erfolgen, welche bei WHERE notiert wird.

---

## Übung - Basis

t>**Aufgabe 1:** Zeige alle Datensätze an, aus denen ersichtlich wird, wann `Niclas Schweizer` seine Fotos gepostet hat.

```SQL
...
```

t>**Aufgabe 1:** Zeige alle Datensätze an, aus denen ersichtlich wird, wann `Niclas Schweizer` seine Fotos gepostet hat.

```SQL
...
```

t>**Aufgabe 2:** Zeige an, welcher Nutzer den Hashtag `#followme` nutzt.

```SQL
...
```

t>**Aufgabe 3:** Zeige an, unter welche Bilder `Niclas Schweizer` alles Kommentare gesetzt hat.


```SQL
...
```

t>**Aufgabe 4:** Zeige alle Datensätze an, aus denen ersichtlich wird, wie viele Fotos welche Person (Klarname) gepostet hat.

```SQL
...
```

t>**Aufgabe 5:** Zeige an, wer User wie viele Follower hat.

```SQL
...
```

t>**Aufgabe 6:** Zeige an, wie viele männliche Follower `Niclas Schweizer` hat.

```SQL
...
```


---

## Wissen für Profis

Konkret spricht man bei der Verknüpfung von Tabellen von sogenannten **Joins**.
Die Verknüpfung gehen auf die Mengenlehre (Venn-Diagramme) zurück.

t>**Aufgabe:** Schaue dir die verschiedenen [Verknüpfungen](https://www.datenbanken-verstehen.de/sql-tutorial/sql-joins/) an und überlege dir Einssatzzwecke bei InstaHub.