# Suche in InstaHub

*Dateiname: instaHub-suchmaske.md*

Viele IT-Systeme geben den BenutzerInnen die Möglichkeit, ohne Kenntnis einer Abfragesprache mehr oder weniger einfache Anfragen an das System zu stellen. Sie heißen dort oft “erweiterte Suche”, “Expertensuche” oder ähnliches.

## Die Suchmaske aufrufen

Du gelangst wie folgt zur Suchmaske:

Klicke auf der Startseite oben rechts das Datenbanken-Symbol, hinter dem sich ein Untermenu befindet, aus dem du den Punkt `Suche` auswählst:

![InstaHub Suchmaske aufrufen](bilder/SuchmaskeMenu.png)

## Die Suchemaske verwenden

Die Suchmaske sieht zunächst sehr aufgeräumt aus:

![InstaHub Suchmaske verwenden](bilder/SuchmaskeVerwenden-1.png)

Wenn du in das Feld `Tabelle auswählen` klickst, erscheint eine Drop-Down-Liste, aus der du eine Tabelle auswählen kannst. Nachdem du eine Tabelle ausgewählt hast, verändert sich die Suchmaske:

![InstaHub Suchmaske verwenden](bilder/SuchmaskeVerwenden-3.png)

Die einzelnen Elemente in der obigen Abbildung haben folgende Bedeutung:

1. Hier siehst du die Tabelle, die du ausgewählt hast und auf die sich dein Suchauftrag bezieht.
2. Wenn du `Spalten filtern` angekreuzt hast, öffnet sich ein Bereich in dem du angeben kannst, welche der Spalten der Tabelle du in deiner Abfrage einfügen willst. Diese Auswahl von Spalten wird in Datenbanken auch **Projektion** genannt:

![InstaHub Suchmaske verwenden](bilder/SuchmaskeVerwenden-4.png)

1. Wenn du `Ergebnisse filtern` ankreuzt, kannst du Kriterien angeben, denen alle ausgegebenen Datensätze entsprechen müssen. Man spricht hier von **Selektion**. Die Details entnehmen Sie bitte dem nächsten Abschnitt “[Selektion in der Suchmaske]”
2. Das Auswahlfeld `Experte` führt zu einigen Optionen, mit deren Hilfe etwas komplexere Abfragen möglich sind. (Diese Möglichkeit wird in diesem Skript nicht behandelt, da wir derartige Abfragen mit der Sprache SQL (siehe Kapitel 4) formulieren werden.)
3. `Zeige SQL`: Die in dem Formular eingegebene Suchabfrage wird in die Sprache SQL übersetzt und ausgegeben.
4. `Ausführen`: Die formulierte Suchabfrage wird ausgeführt.

## Selektion in der Suchmaske

i>Die Selektion, also das Auswählen von Datensätzen aus einer Datenbank an Hand vorgegebener Kriterien ist die vielleicht wichtigste Aufgabe, die ein Datenbankmanagementsystem zu erledigen hat.

Wenn du die Daten von Fabian Möller anzeigen willst, gehst du wie folgt vor:

![InstaHub Suchmaske verwenden](bilder/SuchmaskeVerwenden-5.png)

1. Wähle in der Suchmaske die Tabelle users aus.
2. Wähle Ergebnisse filtern an.
3. Wähle das Feld `name` aus und gib `ist gleich` aus und trage in das leere Feld den Namen `Fabian Möller` ein.
4. Klicke auf Ausführen. InstaHub meldet folgendes Ergebnis:

![InstaHub Suchmaske verwenden](bilder/SuchmaskeVerwenden-6.png)

i>Die Suchmaske kann noch mehr: Du kannst mehrere Filterregeln angeben. Dann musst du angeben, ob die Suchergebnisse **allen** Filterregeln oder **mindestens einer** entsprechen müssen.

t>**Aufgabe**<br />Welche Mitglieder wohnen in Dresden? Gesucht sind Name, Benutzername und Stadt.

```SQL
...
```

t>**Aufgabe**<br />Welche Mitglieder wurden nach dem 01.02.1998 geboren? Gesucht sind Name, Benutzername und Geburtstag.

*Hinweis: Ein Datum wird in folgendem Format gespeichert: `1998-02-01`*

```SQL
...
```
t>**Aufgabe**<br />Welche Mitglieder sind größer als 180 cm und nach dem 01.02.1998 geborgen? Gesucht sind Name, Benutzername und Geburstag.

```SQL
...
```

t>Wie viele Fotos wurden bisher insgesamt hochgeladen?

```SQL
...
```